# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_cmx_lib.api_client import ApiClient


class SupervisorClustersApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def existing_tanzu_clusters(self, self_link_id, **kwargs):  # noqa: E501
        """Get all existing tanzu kubernetes clusters on a supervisor cluster.  # noqa: E501

        Get all existing tanzu kubernetes clusters on a supervisor cluster.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.existing_tanzu_clusters(self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str self_link_id: (required)
        :param str search_term:
        :param str registered:
        :return: list[ClustersIdBody]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.existing_tanzu_clusters_with_http_info(self_link_id, **kwargs)  # noqa: E501
        else:
            (data) = self.existing_tanzu_clusters_with_http_info(self_link_id, **kwargs)  # noqa: E501
            return data

    def existing_tanzu_clusters_with_http_info(self, self_link_id, **kwargs):  # noqa: E501
        """Get all existing tanzu kubernetes clusters on a supervisor cluster.  # noqa: E501

        Get all existing tanzu kubernetes clusters on a supervisor cluster.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.existing_tanzu_clusters_with_http_info(self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str self_link_id: (required)
        :param str search_term:
        :param str registered:
        :return: list[ClustersIdBody]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['self_link_id', 'search_term', 'registered']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method existing_tanzu_clusters" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'self_link_id' is set
        if ('self_link_id' not in params or
                params['self_link_id'] is None):
            raise ValueError("Missing the required parameter `self_link_id` when calling `existing_tanzu_clusters`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'self_link_id' in params:
            path_params['selfLinkId'] = params['self_link_id']  # noqa: E501

        query_params = []
        if 'search_term' in params:
            query_params.append(('searchTerm', params['search_term']))  # noqa: E501
        if 'registered' in params:
            query_params.append(('registered', params['registered']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/cmx/api/resources/supervisor-clusters/{selfLinkId}/tanzu-clusters-namespace', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[ClustersIdBody]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cluster(self, cluster_self_link_id, **kwargs):  # noqa: E501
        """Find a Supervisor Cluster by the id from documentSelfLink  # noqa: E501

        Retrieve a Supervisor Cluster by id from documentSelfLink  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cluster(cluster_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_self_link_id: (required)
        :return: InlineResponseDefault6
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_cluster_with_http_info(cluster_self_link_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cluster_with_http_info(cluster_self_link_id, **kwargs)  # noqa: E501
            return data

    def get_cluster_with_http_info(self, cluster_self_link_id, **kwargs):  # noqa: E501
        """Find a Supervisor Cluster by the id from documentSelfLink  # noqa: E501

        Retrieve a Supervisor Cluster by id from documentSelfLink  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cluster_with_http_info(cluster_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_self_link_id: (required)
        :return: InlineResponseDefault6
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_self_link_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cluster" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_self_link_id' is set
        if ('cluster_self_link_id' not in params or
                params['cluster_self_link_id'] is None):
            raise ValueError("Missing the required parameter `cluster_self_link_id` when calling `get_cluster`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_self_link_id' in params:
            path_params['clusterSelfLinkId'] = params['cluster_self_link_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/cmx/api/resources/supervisor-clusters/{clusterSelfLinkId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponseDefault6',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cluster1(self, endpoint_self_link_id, moref, **kwargs):  # noqa: E501
        """Find a Supervisor Cluster by vSphere moref and vSphere endpoint id  # noqa: E501

        Retrieve a Supervisor Cluster by vSphere moref and id from the endpoint self link of the vSphere endpoint this cluster is associated to  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cluster1(endpoint_self_link_id, moref, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_self_link_id: (required)
        :param str moref: (required)
        :return: InlineResponseDefault6
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_cluster1_with_http_info(endpoint_self_link_id, moref, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cluster1_with_http_info(endpoint_self_link_id, moref, **kwargs)  # noqa: E501
            return data

    def get_cluster1_with_http_info(self, endpoint_self_link_id, moref, **kwargs):  # noqa: E501
        """Find a Supervisor Cluster by vSphere moref and vSphere endpoint id  # noqa: E501

        Retrieve a Supervisor Cluster by vSphere moref and id from the endpoint self link of the vSphere endpoint this cluster is associated to  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cluster1_with_http_info(endpoint_self_link_id, moref, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_self_link_id: (required)
        :param str moref: (required)
        :return: InlineResponseDefault6
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['endpoint_self_link_id', 'moref']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cluster1" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'endpoint_self_link_id' is set
        if ('endpoint_self_link_id' not in params or
                params['endpoint_self_link_id'] is None):
            raise ValueError("Missing the required parameter `endpoint_self_link_id` when calling `get_cluster1`")  # noqa: E501
        # verify the required parameter 'moref' is set
        if ('moref' not in params or
                params['moref'] is None):
            raise ValueError("Missing the required parameter `moref` when calling `get_cluster1`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'endpoint_self_link_id' in params:
            path_params['endpointSelfLinkId'] = params['endpoint_self_link_id']  # noqa: E501
        if 'moref' in params:
            path_params['moref'] = params['moref']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/cmx/api/resources/supervisor-clusters/endpoint/{endpointSelfLinkId}/cluster/{moref}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponseDefault6',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list2(self, **kwargs):  # noqa: E501
        """Get all managed Supervisor Clusters  # noqa: E501

        Get all managed Supervisor Clusters  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list2(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is ascending.
        :return: InlineResponse2009
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list2_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.list2_with_http_info(**kwargs)  # noqa: E501
            return data

    def list2_with_http_info(self, **kwargs):  # noqa: E501
        """Get all managed Supervisor Clusters  # noqa: E501

        Get all managed Supervisor Clusters  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list2_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is ascending.
        :return: InlineResponse2009
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['page', 'size', 'sort', 'top', 'skip', 'orderby']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list2" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
            collection_formats['sort'] = 'multi'  # noqa: E501
        if 'top' in params:
            query_params.append(('$top', params['top']))  # noqa: E501
        if 'skip' in params:
            query_params.append(('$skip', params['skip']))  # noqa: E501
        if 'orderby' in params:
            query_params.append(('$orderby', params['orderby']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/cmx/api/resources/supervisor-clusters', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2009',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_clusters_on_endpoint(self, endpoint_self_link_id, **kwargs):  # noqa: E501
        """Get all Supervisor Clusters on a vSphere endpoint  # noqa: E501

        Get all Supervisor Clusters on a vSphere endpoint by provided id from the endpoint self link  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_clusters_on_endpoint(endpoint_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_self_link_id: (required)
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param str registered:
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is ascending.
        :return: InlineResponse2009
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_clusters_on_endpoint_with_http_info(endpoint_self_link_id, **kwargs)  # noqa: E501
        else:
            (data) = self.list_clusters_on_endpoint_with_http_info(endpoint_self_link_id, **kwargs)  # noqa: E501
            return data

    def list_clusters_on_endpoint_with_http_info(self, endpoint_self_link_id, **kwargs):  # noqa: E501
        """Get all Supervisor Clusters on a vSphere endpoint  # noqa: E501

        Get all Supervisor Clusters on a vSphere endpoint by provided id from the endpoint self link  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_clusters_on_endpoint_with_http_info(endpoint_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_self_link_id: (required)
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param str registered:
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is ascending.
        :return: InlineResponse2009
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['endpoint_self_link_id', 'page', 'size', 'sort', 'registered', 'top', 'skip', 'orderby']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_clusters_on_endpoint" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'endpoint_self_link_id' is set
        if ('endpoint_self_link_id' not in params or
                params['endpoint_self_link_id'] is None):
            raise ValueError("Missing the required parameter `endpoint_self_link_id` when calling `list_clusters_on_endpoint`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'endpoint_self_link_id' in params:
            path_params['endpointSelfLinkId'] = params['endpoint_self_link_id']  # noqa: E501

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
            collection_formats['sort'] = 'multi'  # noqa: E501
        if 'registered' in params:
            query_params.append(('registered', params['registered']))  # noqa: E501
        if 'top' in params:
            query_params.append(('$top', params['top']))  # noqa: E501
        if 'skip' in params:
            query_params.append(('$skip', params['skip']))  # noqa: E501
        if 'orderby' in params:
            query_params.append(('$orderby', params['orderby']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/cmx/api/resources/supervisor-clusters/endpoint/{endpointSelfLinkId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2009',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def register1(self, cluster_self_link_id, **kwargs):  # noqa: E501
        """Make a Supervisor Cluster a managed entity  # noqa: E501

        A valid document self link id shall be provided.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.register1(cluster_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_self_link_id: (required)
        :return: InlineResponseDefault6
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.register1_with_http_info(cluster_self_link_id, **kwargs)  # noqa: E501
        else:
            (data) = self.register1_with_http_info(cluster_self_link_id, **kwargs)  # noqa: E501
            return data

    def register1_with_http_info(self, cluster_self_link_id, **kwargs):  # noqa: E501
        """Make a Supervisor Cluster a managed entity  # noqa: E501

        A valid document self link id shall be provided.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.register1_with_http_info(cluster_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_self_link_id: (required)
        :return: InlineResponseDefault6
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_self_link_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method register1" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_self_link_id' is set
        if ('cluster_self_link_id' not in params or
                params['cluster_self_link_id'] is None):
            raise ValueError("Missing the required parameter `cluster_self_link_id` when calling `register1`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_self_link_id' in params:
            path_params['clusterSelfLinkId'] = params['cluster_self_link_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/cmx/api/resources/supervisor-clusters/{clusterSelfLinkId}/register', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponseDefault6',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def unregister(self, cluster_self_link_id, **kwargs):  # noqa: E501
        """Make a Supervisor Cluster an unmanaged entity  # noqa: E501

        A valid document self link id shall be provided.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.unregister(cluster_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_self_link_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.unregister_with_http_info(cluster_self_link_id, **kwargs)  # noqa: E501
        else:
            (data) = self.unregister_with_http_info(cluster_self_link_id, **kwargs)  # noqa: E501
            return data

    def unregister_with_http_info(self, cluster_self_link_id, **kwargs):  # noqa: E501
        """Make a Supervisor Cluster an unmanaged entity  # noqa: E501

        A valid document self link id shall be provided.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.unregister_with_http_info(cluster_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_self_link_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_self_link_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method unregister" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_self_link_id' is set
        if ('cluster_self_link_id' not in params or
                params['cluster_self_link_id'] is None):
            raise ValueError("Missing the required parameter `cluster_self_link_id` when calling `unregister`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_self_link_id' in params:
            path_params['clusterSelfLinkId'] = params['cluster_self_link_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/cmx/api/resources/supervisor-clusters/{clusterSelfLinkId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
